/*
The main classis a QUANTAnet_blockingTcpServer_c which support blocking 
accept function. Everything else would be the same as the parent class, 
QUANTAnet_tcpServer_c.
*/

#ifndef _QUANTAPLUS_BLOCKINGTCP_C
#define _QUANTAPLUS_BLOCKINGTCP_C

#ifdef WIN32
#include <errno.h>
#elif defined(__sgi)
extern int errno;
#endif

#include "QUANTAnet_tcp_c.hxx"

class QUANTAnet_blockingTcpClient_c : public QUANTAnet_tcpClient_c {
public:
	void setTimeOutPeriod(int t) { timeOutPeriod = t; }
	void setClientInfo(struct sockaddr_in cliInfo) { clientInfo = cliInfo; }
	void setClientSockFD(int fd) { clientSockFd = fd; }
};

/** TCP Class for creating servers. This class bypasses QUANTA's standard method for establishing connections and provides the user with direct control of TCP connections.
*/
class QUANTAnet_blockingTcpServer_c : public QUANTAnet_tcpServer_c {
public:
	/** Check to see if there is a request from clients for connection.
	 * If yes then return a QUANTAnet_tcpClient_c object which you can then use
	 * to talk to the client.
	 * @see QUANTAnet_tcpClient_c class.
	 */
	QUANTAnet_tcpClient_c *checkForNewConnections();
};

#endif
