#include "QUANTA/QUANTAinit.hxx"
#include "QUANTA/QUANTAnet_tcp_c.hxx"
#include "profile.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <iostream>
#include <vector>
#include <string>
using namespace std; 

/* This is the size of all messages sent from clients to servers. */
#define TRANSMITTED_DATA_SIZE 512
#define APPLICATION_LAUNCH_PORT 32392
vector<string> serverAddresses;
vector<QUANTAnet_tcpClient_c*> clients;

void ParseServerRange(char *ip)
{
	char name[1024];
	strcpy(name, ip);
	char *startingAddress = strchr(name, '-');
	if (startingAddress) {
		char *endingNumber = startingAddress + 1;
		*startingAddress = '\0';
		char *startingNumber = strrchr(name, '.');
		*startingNumber = '\0';
		int sn = atoi(startingNumber + 1);
		int en = atoi(endingNumber);
		string s(name);
		for (int i = sn; i <= en; i++) {
			char temp[100];
			itoa(i, temp, 10);
			string newS = s + "." + temp;
			serverAddresses.push_back(newS);
		}
	}
	else {
		string s(name);
		serverAddresses.push_back(s);
	}
}

void SetAddress()
{
	char *serverAddresses;

	serverAddresses = getPrivateProfileString("Network", "Servers", "127.0.0.1", "ServerConfig.ini");
	if (serverAddresses) {
		char name[1024];
		strcpy(name, serverAddresses);
		free(serverAddresses);

		char *ip = strtok(name, ":");
		if (ip == NULL) return;
		while (ip) {
			ParseServerRange(ip);
			ip = strtok(NULL, ":");
		}
	}
}

void readInput(char* buffer)
{
	printf("Type your application command: ");
	fgets(buffer, TRANSMITTED_DATA_SIZE, stdin);
}

void SetConnections()
{
	for (vector<string>::iterator it = serverAddresses.begin(); it != serverAddresses.end(); it++) {
		QUANTAnet_tcpClient_c *client = new QUANTAnet_tcpClient_c;
		int status = client->connectToServer((*it).c_str(), APPLICATION_LAUNCH_PORT);
		if (status > 0) {
			printf("Conenct to application server: %s %d\n", (*it).c_str(), APPLICATION_LAUNCH_PORT);
			clients.push_back(client);
		}
	}
}

void SendCommand(char* buffer)
{
	for (vector<QUANTAnet_tcpClient_c*>::iterator it = clients.begin(); it != clients.end(); it++) {
		int dataSize = TRANSMITTED_DATA_SIZE;
		(*it)->write(buffer, &dataSize, QUANTAnet_tcpClient_c::BLOCKING);
	}
}

void CleanConnections()
{
	vector<QUANTAnet_tcpClient_c*>::iterator it = clients.begin();
	while (it != clients.end()) {
		(*it)->close();
		delete (*it);
		it = clients.erase(it);
	}
}

int main(int argc, char** argv)
{
	QUANTAinit();

	SetAddress();
	SetConnections();

	char sendCommand[TRANSMITTED_DATA_SIZE];
	for (int i = 0; i < 5; i++)
	{
		readInput(sendCommand); // read application command
		SendCommand(sendCommand);
	}

	CleanConnections();
	printf("ended\n");

	return 0;
}